#include <bits/stdc++.h>
using namespace std;

ifstream fin ("baruri.in");
ofstream fout ("baruri.out");

const int NMAX = 100003;
int aib [NMAX];
int n, T, B, A, q, X, Y, d, type;

void Update(int poz, int val)
{
    for (int i = poz; i <= n; i += i & -i )
        aib[i] += val;
}

int Query(int poz)
{
    long long sum = 0;
    for (int i = poz; i >= 1; i -= i & -i)
        sum += aib [i];

    return sum;
}

int main ()
{
    fin >> T;
    for (int t = 1; t <= T; t ++)
    {
        fin >> n;
        for (int i = 1; i <= NMAX - 3; i ++)
			aib[i] = 0;

        for (int i = 1; i <= n; i ++) // O(n * log2(n))
        {
            fin >> A;
            Update(i, A);
        }

        fin >> q;
        for (int i = 1; i <= q; i ++)
        {
            fin >> type;
            if (type == 1)
            {
                fin >> A >> B;
                Update(B, A);
            }
            else if (type == 2)
            {
                fin >> A >> B;
                Update(B, -A);
            }
            else if (type == 3)
            {
                fin >> A >> X >> Y;
                Update(X, -A);
                Update(Y , A);
            }
            else if (type == 0)
            {
                fin >> B >> d;
                fout << Query(B - 1) - Query(B) + Query(min(B + d, n)) - Query(max(B - d - 1, 0)) << '\n';
            }
        }
    }

    return 0;
}
