#include <fstream>
using namespace std;

ifstream fin("datorii.in");
ofstream fout("datorii.out");

int n, m, x, aib[15005], c, a, b;


void Add(int x, int val)
{
    for(int i = x; i <= n; i += i & -i)
        aib[i] += val;
}

int sum(int x)
{
    int s = 0;
    for(int i = x; i >= 1; i -= i & -i)
        s += aib[i];

    return s;
}

int main()
{
    fin >> n >> m;

    for(int i = 1; i <= n; ++i)
    {
        fin >> x;
        Add(i, x);  // update
    }

    for(int i = 1; i <= m; ++i)
    {
        fin >> c >> a >> b;

        if (c == 0)
            Add(a, -b);
        else if(c == 1)
            fout << sum(b) - sum(a - 1) << '\n';
    }

    return 0;
}
